// DrawNewunitByMouse.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "group.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "DrawNewunitByMouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DrawNewunitByMouse dialog


DrawNewunitByMouse::DrawNewunitByMouse(CWnd* pParent /*=NULL*/)
  : CDialog(DrawNewunitByMouse::IDD, pParent)
{
  //{{AFX_DATA_INIT(DrawNewunitByMouse)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void DrawNewunitByMouse::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(DrawNewunitByMouse)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  DDX_Control(pDX, IDC_VGCTRL2, toolbar);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DrawNewunitByMouse, CDialog)
  //{{AFX_MSG_MAP(DrawNewunitByMouse)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
  ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
  ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
  ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
  ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
  ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
  ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
  ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
  ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
  ON_BN_CLICKED(IDC_BUTTON13, OnButton13)
  ON_BN_CLICKED(IDC_BUTTON14, OnButton14)
  ON_BN_CLICKED(IDC_BUTTON15, OnButton15)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DrawNewunitByMouse message handlers

BOOL DrawNewunitByMouse::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  toolbar.Run("http://www.visual-graph.com/activex/newunit.xml");
  vg1.Design("");
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  toolbar.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  
  return TRUE;
}

void DrawNewunitByMouse::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    toolbar.MoveWindow( 0, 0, cx, 40 );
    vg1.MoveWindow( 0, 40, cx, cy - 100 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 100, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON3 );
    bt->MoveWindow( 200, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON4 );
    bt->MoveWindow( 300, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON5 );
    bt->MoveWindow( 400, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON6 );
    bt->MoveWindow( 500, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON7 );
    bt->MoveWindow( 600, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON8 );
    bt->MoveWindow( 700, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON9 );
    bt->MoveWindow( 0, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON10 );
    bt->MoveWindow( 100, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON11 );
    bt->MoveWindow( 200, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON12 );
    bt->MoveWindow( 300, cy - 30, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON13 );
    bt->MoveWindow( 450, cy - 30, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON14 );
    bt->MoveWindow( 600, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON15 );
    bt->MoveWindow( 700, cy - 30, 100, 20 );
  };
}

void DrawNewunitByMouse::OnButton1() 
{
  vg1.GetVg().NewUnit( NULL, "rect" );
}

void DrawNewunitByMouse::OnButton2() 
{
  vg1.GetVg().NewUnit( NULL, "line" );
}

void DrawNewunitByMouse::OnButton3() 
{
  vg1.GetVg().NewUnit( NULL, "circle" );
}

void DrawNewunitByMouse::OnButton4() 
{
  vg1.GetVg().NewUnit( NULL, "arc" );
}

void DrawNewunitByMouse::OnButton5() 
{
  vg1.GetVg().NewUnit( NULL, "pie" );
}

void DrawNewunitByMouse::OnButton6() 
{
    Cvg lb = vg1.GetVg().Create(vg1.GetDefaultPath() + "controls.tbl", true, false);
    CUnit bt = vg1.GetVg().NewUnit(lb, "button");
    if (bt)
        bt.SetLib( vg1.GetVg().GetFileName() );//element link to library
    lb.Free();
}

void DrawNewunitByMouse::OnButton7() 
{
    Cvg lb = vg1.GetVg().Create(vg1.GetDefaultPath() + "controls.tbl", true, false);
    CUnit bt = vg1.GetVg().NewUnit(lb, "listbox");
    if (bt)
        bt.SetLib( vg1.GetVg().GetFileName() );//element link to library
    lb.Free();  
}

void DrawNewunitByMouse::OnButton8() 
{
    Cvg lb = vg1.GetVg().Create(vg1.GetDefaultPath() + "controls.tbl", true, false);
    CUnit bt = vg1.GetVg().NewUnit(lb, "vscrollbar");
    if (bt)
        bt.SetLib( vg1.GetVg().GetFileName() );//element link to library
    lb.Free();
}

void DrawNewunitByMouse::OnButton9() 
{
    Cvg lb = vg1.GetVg().Create("http://www.visual-graph.com/activex/power.xml", true, false);
    vg1.GetVg().NewUnit(lb, "TransformerB");//this element will embed to the file
    lb.Free();
}

void DrawNewunitByMouse::OnButton10() 
{
    Cvg lb = vg1.GetVg().Create("http://www.visual-graph.com/activex/power.xml", true, false);
    vg1.GetVg().NewUnit(lb, "VGround");//this element will embed to the file
    lb.Free();
}

void DrawNewunitByMouse::OnButton11() 
{
    if (vg1.GetVg().GetSelection().GetUnitCount() == 1)
    {
        CUnit d = vg1.GetVg().GetSelection().GetUnits(0);
        vg1.GetVg().GetActiveSheet().DeleteUnit(d);
    }else
        MessageBox("Please select a unit first.");
}

void DrawNewunitByMouse::OnButton12() 
{
    int i = 0;
    CString s = "";
    while (i < vg1.GetVg().GetSelection().GetUnitCount())
    {
        CUnit d = vg1.GetVg().GetSelection().GetUnits(i);
        s = s + d.GetName() + ",";
        i = i + 1;
    };
    MessageBox(s);
}

void DrawNewunitByMouse::OnButton13() 
{
    if (vg1.GetVg().GetSelection().GetUnitCount() != 0)
    {
        vg1.GetVg().DeleteSelection();
    }else
        MessageBox("There are no units selected.");
}

void DrawNewunitByMouse::OnButton14() 
{
  vg1.GetVg().Undo();
}

void DrawNewunitByMouse::OnButton15() 
{
  vg1.GetVg().Redo();
}
