// ResizeaUnit.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "group.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "ResizeaUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ResizeaUnit dialog


ResizeaUnit::ResizeaUnit(CWnd* pParent /*=NULL*/)
  : CDialog(ResizeaUnit::IDD, pParent)
{
  //{{AFX_DATA_INIT(ResizeaUnit)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void ResizeaUnit::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(ResizeaUnit)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ResizeaUnit, CDialog)
  //{{AFX_MSG_MAP(ResizeaUnit)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ResizeaUnit message handlers

void ResizeaUnit::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 150, cy - 50, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON3 );
    bt->MoveWindow( 300, cy - 50, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON4 );
    bt->MoveWindow( 450, cy - 50, 150, 20 );
  };
}

BOOL ResizeaUnit::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Design("http://www.visual-graph.com/activex/onresize.xml");
  return TRUE;
};

void ResizeaUnit::OnButton1() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CUnit d = sheet.UnitByName("element2");
  if( d )
  {
    char buffer[256];
    sprintf( buffer, "[%f,%f]-[%f,%f]", d.GetLeft(), d.GetTop(), d.GetRight(), d.GetBottom() );
    MessageBox( buffer );
  };
}

void ResizeaUnit::OnButton2() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CUnit d = sheet.UnitByName("element2");
    if( d )
        d.SetBounds(100, 200, 300, 60);  
}

void ResizeaUnit::OnButton3() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CUnit d = sheet.UnitByName("element2");
    CGroup selection = vg.GetSelection();
  selection.Clear();
    selection.Add(d);
    Cvg dlg = vg.Create("http://www.visual-graph.com/activex/orgdlg.xml", false, false);
    VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  dlg.GetActiveSheet().SetPropertyValue("CurSheet", v);
    dlg.ShowModal();
    dlg.Free();
    vg.Rotate();
}

void ResizeaUnit::OnButton4() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CUnit d = sheet.UnitByName("element2");
    if( d )
    {
        d.SetProtect( 56 );//forbid to delete, mirror and change width
      CGroup selection = vg.GetSelection();
        selection.Clear();
        selection.Add(d);
    }
}
