﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csharpdemo
{
    public partial class FrmAddaUnit : Form
    {
        public FrmAddaUnit()
        {
            InitializeComponent();
        }

        private void FrmAddaUnit_Load(object sender, EventArgs e)
        {
            toolbar.Run("http://www.visual-graph.com/activex/addunit.xml");
            vg1.Design("");
            toolbar.vg.ActiveSheet.SetPropertyValue("cursheet", vg1.vg.ActiveSheet);
            toolbar.Height = 40;
        }

        private void btnRect_Click(object sender, EventArgs e)
        {
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit(null, "rect");
          d.SetBounds( 0, 100, 100, 100 );
          d.BackColor = 0xFF00;
        }

        private void btnline_Click(object sender, EventArgs e)
        {
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit(null, "line");
          d.PointCount = 2;
          d.x[0] = 100;
          d.y[0] = 100;
          d.x[1] = 200;
          d.y[1] = 200;
          d.Refresh();
          d.LineWidth = 8;
          d.EndArrow = 1;
        }

        private void btncircle_Click(object sender, EventArgs e)
        {
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit(null, "circle");
          d.SetBounds( 200, 100, 100, 100 );
          d.BackColor = 0xFF;
        }

        private void btnarc_Click(object sender, EventArgs e)
        {
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit(null, "arc");
          d.SetBounds( 300, 100, 100, 100 );
          d.StartAngle = 45;
          d.EndAngle = 315;
          d.LineWidth = 8;
          d.BackColor = 0xFF0000;
        }

        private void btnpie_Click(object sender, EventArgs e)
        {
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit( null, "pie" );
          d.SetBounds( 400, 100, 100, 100 );
          d.StartAngle = 45;
          d.EndAngle = 315;
          d.LineWidth = 8;
          d.BackColor = 0xFF0000;
        }

        private void btnbutton_Click(object sender, EventArgs e)
        {
          vg.Ivg doc = vg1.vg.Create( vg1.DefaultPath + "controls.tbl", true, false );
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit(doc, "button" );
          d.MoveTo( 500, 150 - d.Height / 2 );
          d.Lib = doc.FileName;
          doc.Free();
        }

        private void btnlistbox_Click(object sender, EventArgs e)
        {
          vg.Ivg doc = vg1.vg.Create( vg1.DefaultPath + "controls.tbl", true, false );
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit( doc, "listbox" );
          d.SetBounds( 600, 100, 100, 100 );
          d.Execute( "AddItem( 'Item1' )" );
          d.Execute( "AddItem( 'Item2' )" );
          d.Execute( "AddItem( 'Item3' )" );
          d.Lib = doc.FileName;
          doc.Free();
        }

        private void btnscrollbar_Click(object sender, EventArgs e)
        {
          vg.Ivg doc = vg1.vg.Create( vg1.DefaultPath + "controls.tbl", true, false );
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit( doc, "vscrollbar" );
          d.MoveTo( 750 - d.Width / 2, 100 );
          d.Height = 100;
          d.Lib = doc.FileName;
          doc.Free();
        }

        private void btntransformer_Click(object sender, EventArgs e)
        {
          vg.Ivg doc = vg1.vg.Create( "http://www.visual-graph.com/activex/power.xml", true, false );
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit( doc, "TransformerB" );
          d.MoveTo( 850 - d.Width / 2, 150 - d.Height / 2 );
          d.Lib = doc.FileName;
          doc.Free();
        }

        private void btnground_Click(object sender, EventArgs e)
        {
          vg.Ivg doc = vg1.vg.Create( "http://www.visual-graph.com/activex/power.xml", true, false );
          vg.IUnit d = vg1.vg.ActiveSheet.AddUnit( doc, "VGround" );
          d.MoveTo( 950 - d.Width / 2, 150 - d.Height / 2 );
          d.Lib = doc.FileName;
          doc.Free();
        }

        private void toolbar_OnCommand(object sender, Axvg._IvgctrlEvents_OnCommandEvent e)
        {

        }
    }
}
