unit CreateUnitFromXML;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmCreateUnitFromXML = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCreateUnitFromXML: TfrmCreateUnitFromXML;

implementation

{$R *.dfm}

procedure TfrmCreateUnitFromXML.FormShow(Sender: TObject);
begin
  vg1.Run( 'http://www.visual-graph.com/activex/xml.xml' );
end;

procedure TfrmCreateUnitFromXML.Button4Click(Sender: TObject);
begin
  vg1.vg.LoadFromBuffer( Memo1.Text );
end;

procedure TfrmCreateUnitFromXML.Button1Click(Sender: TObject);
var
  d : IUnit;
begin
  d := vg1.vg.ActiveSheet.AddUnit( nil, 'rect' );
  d.LoadFromBuffer( Memo2.Text );
end;

procedure TfrmCreateUnitFromXML.Button2Click(Sender: TObject);
var
  d : IUnit;
begin
  d := vg1.vg.ActiveSheet.AddUnit( nil, 'element' );
  d.LoadFromBuffer( Memo3.Text );
end;

procedure TfrmCreateUnitFromXML.Button3Click(Sender: TObject);
var
  d : IUnit;
begin
  d := vg1.vg.ActiveSheet.AddUnit( nil, 'element' );
  d.LoadFromBuffer( Memo4.Text );
end;

end.
